#include<bits/stdc++.h>
using namespace std;
int n,m,d[500100],f[500100];
vector<int>a[500100];
void q(int x,int fa)
{
	d[x]=d[fa]+1;
	for(int i=0;i<a[x].size();i++)
	{
		int v=a[x][i];
		if(v!=fa)
		{
			q(v,x);
		}
	}
}
void p(int x,int fa,int l,int r)
{
	f[x]=0;
	if(l<=x&&x<=r)
	{
		f[x]=1;
	}
	for(int i=0;i<a[x].size();i++)
	{
		int v=a[x][i];
		if(v!=fa)
		{
			p(v,x,l,r);
			f[x]+=f[v];
		}
	}
}
int main()
{
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	cin>>n;
	for(int i=1;i<n;i++)
	{
		int x,y;
		scanf("%d%d",&x,&y);
		a[x].push_back(y);
		a[y].push_back(x); 
	}
	cin>>m;
	q(1,0);
	for(;m--;)
	{
		int l,r,k;
		cin>>l>>r>>k;
		p(1,0,l,r);
		int s=1;
		for(int i=1;i<=n;i++)
		{
			if(f[i]>=k)
			{
				s=max(s,d[i]);
			}
		}
		printf("%d\n",s);
 	} 
	return 0;
}
